/* Generated by wayland-scanner 1.12.0 */

#ifndef CUSTOM_CLIENT_PROTOCOL_H
#define CUSTOM_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_custom The custom protocol
 * @section page_ifaces_custom Interfaces
 * - @subpage page_iface_qt_example_extension - 
 * @section page_copyright_custom Copyright
 * <pre>
 *
 * Copyright (C) 2015 The Qt Company Ltd.
 * Contact: http://www.qt.io/licensing/
 *
 * This file is part of the examples of the Qt Wayland module
 *
 * $QT_BEGIN_LICENSE:BSD$
 * You may use this file under the terms of the BSD license as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 * </pre>
 */
struct qt_example_extension;
struct wl_surface;

/**
 * @page page_iface_qt_example_extension qt_example_extension
 * @section page_iface_qt_example_extension_api API
 * See @ref iface_qt_example_extension.
 */
/**
 * @defgroup iface_qt_example_extension The qt_example_extension interface
 */
extern const struct wl_interface qt_example_extension_interface;

/**
 * @ingroup iface_qt_example_extension
 * @struct qt_example_extension_listener
 */
struct qt_example_extension_listener {
	/**
	 * Qt example event
	 *
	 * Example event from server to client
	 */
	void (*qtevent)(void *data,
			struct qt_example_extension *qt_example_extension,
			struct wl_surface *surface,
			uint32_t time,
			const char *text,
			uint32_t value);
};

/**
 * @ingroup qt_example_extension_iface
 */
static inline int
qt_example_extension_add_listener(struct qt_example_extension *qt_example_extension,
				  const struct qt_example_extension_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) qt_example_extension,
				     (void (**)(void)) listener, data);
}

#define QT_EXAMPLE_EXTENSION_QTREQUEST 0

/**
 * @ingroup iface_qt_example_extension
 */
#define QT_EXAMPLE_EXTENSION_QTEVENT_SINCE_VERSION 1

/**
 * @ingroup iface_qt_example_extension
 */
#define QT_EXAMPLE_EXTENSION_QTREQUEST_SINCE_VERSION 1

/** @ingroup iface_qt_example_extension */
static inline void
qt_example_extension_set_user_data(struct qt_example_extension *qt_example_extension, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qt_example_extension, user_data);
}

/** @ingroup iface_qt_example_extension */
static inline void *
qt_example_extension_get_user_data(struct qt_example_extension *qt_example_extension)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qt_example_extension);
}

static inline uint32_t
qt_example_extension_get_version(struct qt_example_extension *qt_example_extension)
{
	return wl_proxy_get_version((struct wl_proxy *) qt_example_extension);
}

/** @ingroup iface_qt_example_extension */
static inline void
qt_example_extension_destroy(struct qt_example_extension *qt_example_extension)
{
	wl_proxy_destroy((struct wl_proxy *) qt_example_extension);
}

/**
 * @ingroup iface_qt_example_extension
 *
 * Example request from client to server
 */
static inline void
qt_example_extension_qtrequest(struct qt_example_extension *qt_example_extension, const char *text, int32_t value)
{
	wl_proxy_marshal((struct wl_proxy *) qt_example_extension,
			 QT_EXAMPLE_EXTENSION_QTREQUEST, text, value);
}

#ifdef  __cplusplus
}
#endif

#endif
