#include "qwayland-share-buffer.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_share_buffer::qt_share_buffer(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_share_buffer::qt_share_buffer(struct ::qt_share_buffer *obj)
        : m_qt_share_buffer(obj)
    {
        init_listener();
    }

    qt_share_buffer::qt_share_buffer()
        : m_qt_share_buffer(0)
    {
    }

    qt_share_buffer::~qt_share_buffer()
    {
    }

    void qt_share_buffer::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_share_buffer = static_cast<struct ::qt_share_buffer *>(wl_registry_bind(registry, id, &qt_share_buffer_interface, version));
        init_listener();
    }

    void qt_share_buffer::init(struct ::qt_share_buffer *obj)
    {
        m_qt_share_buffer = obj;
        init_listener();
    }

    bool qt_share_buffer::isInitialized() const
    {
        return m_qt_share_buffer != 0;
    }

    const struct wl_interface *qt_share_buffer::interface()
    {
        return &::qt_share_buffer_interface;
    }

    void qt_share_buffer::share_buffer_cross_buffer(struct ::qt_server_buffer *)
    {
    }

    void qt_share_buffer::handle_cross_buffer(
        void *data,
        struct ::qt_share_buffer *object,
        struct ::qt_server_buffer *buffer)
    {
        Q_UNUSED(object);
        static_cast<qt_share_buffer *>(data)->share_buffer_cross_buffer(
            buffer);
    }

    const struct qt_share_buffer_listener qt_share_buffer::m_qt_share_buffer_listener = {
        qt_share_buffer::handle_cross_buffer
    };

    void qt_share_buffer::init_listener()
    {
        qt_share_buffer_add_listener(m_qt_share_buffer, &m_qt_share_buffer_listener, this);
    }
}

QT_END_NAMESPACE
